-- Util class ImageButton to make fading and noisy buttons
require "class.Rectangle"
class "ImageButton"{
}

function ImageButton:__init__()
    self.hover      =   false
    self.alpha      =   0
    self.image      =   nil
    self.label      =   nil
    self.rect       =   nil
    self.fadeSpeed  =   400
    self.hoversound =   nil
    self.clicksound =   nil

end

function ImageButton:loadImage(p_path)
    self.image  =   love.graphics.newImage(p_path)
    self.rect   =   Rectangle(0, 0, self.image:getWidth(), self.image:getHeight() )

end

function ImageButton:setImage(p_img)
    self.image  =   p_img
    self.rect   =   Rectangle(0, 0, self.image:getWidth(), self.image:getHeight() )

end

function ImageButton:loadLabelImage(p_path)
    self.label  =   love.graphics.newImage(p_path)

end

function ImageButton:setLabelImage(p_img)
    self.label  =   p_img

end

function ImageButton:loadHoverSound(p_path)
	self.hoversound	 =   love.audio.newSource(p_path, "static")
	self.hoversound:stop()

end

function ImageButton:loadClickSound(p_path)
	self.clicksound	 =	love.audio.newSource(p_path, "static")
	self.clicksound:stop()

end

function ImageButton:setHoverSound(p_sound)
    self.hoversound  =   p_sound
    self.hoversound:stop()
end

function ImageButton:setClickSound(p_sound)
    self.clicksound =   p_sound
    self.clicksound:stop()

end

function ImageButton:click()
    if self.clicksound then
        self.clicksound:stop()
        self.clicksound:play()
    end
end

function ImageButton:setCenter(p_x, p_y)
    self.rect:setCenter(p_x, p_y)

end

function ImageButton:update(dt)
    if self.hover then
        self.alpha    =   self.alpha + self.fadeSpeed * dt
        self.alpha    =   clamp(self.alpha, 0, 255)
        if self.hoversound and self.hoversound:isStopped() then
			self.hoversound:stop()
			--self.hoversound:play()
			self.hoversound:play()
		end
    else
        self.alpha    =   self.alpha - self.fadeSpeed * dt
        self.alpha    =   clamp(self.alpha, 0, 255)
        if self.hoversound then self.hoversound:stop() end
    end

end

function ImageButton:draw()
    if self.idleImage then
        love.graphics.setColor(255, 255, 255, 255)
        love.graphics.draw(self.idleImage, self.rect.x, self.rect.y)
    end
    love.graphics.setColor(255, 255, 255, self.alpha)
    love.graphics.draw(self.image, self.rect.x, self.rect.y)
    love.graphics.draw(self.label, self.rect.x, self.rect.y)
end
