------------------------------------------------------------------------
-- @class Nutriment
-- Class representing a rich underground nutriment zone
------------------------------------------------------------------------

class "Nutriment"{
}


function Nutriment:__init__()
    self.x_pos, self.y_pos  =   0, 0
    self.resource           =   math.random(50, 75)
    self.dead               =   false
    self.selected           =   false
    self.hovered            =   false

end


function Nutriment:setPosition(p_x, p_y)
    self.x_pos  =   p_x or 0
    self.y_pos  =   p_y or 0
    self.pos    =   {x=p_x, y=p_y}

end

function Nutriment:update(dt)
    if self.resource <= 0 then
        self.dead    =    false
    end

end

function Nutriment:draw()
    love.graphics.setColor(230, 105, 30, 90)
    love.graphics.circle("fill", self.x_pos, self.y_pos, 15 )
    if self.selected then
        love.graphics.setColor(260, 155, 80, 255)
    elseif self.hovered then
        love.graphics.setColor(255, 255, 255, 125)
    else
        love.graphics.setColor(210, 105, 30, 255)
    end
    love.graphics.circle("fill", self.x_pos, self.y_pos, math.log(self.resource*10) )

end
