------------------------------------------------------------------------
-- GRAPHICS_OPTION - let's choose thoses graphical options
------------------------------------------------------------------------

graphicsoption              =   Gamestate.new()
graphicsoption.position     =   vector(1650, -40)
graphicsoption.rotation     =   0
graphicsoption.zoom         =   1.5


function graphicsoption:enter()
    print("Entering display options")
    --~ resolutions =   love.graphics.getModes()

    -- Creating list of items
    if GAMECONFIG.options["fullscreen"]     then fs = "on" else fs = "off" end
    if GAMECONFIG.options["post-process"]   then pp = "on" else pp = "off" end
    res_value   =   GAMECONFIG.options["width"] .. " x " .. GAMECONFIG.options["height"]

    item_list   =   {"Resolution", "Fullscreen", "Post processing", "Back"}
    value_list  =   {res_value, GAMECONFIG.options["fullscreen"], GAMECONFIG.options["post-process"], nil}

    line_offset =   (love.graphics.getHeight()/2) / #item_list
    line_offset =   line_offset -   big_font:getHeight()

    menu        =   {}

    ypos  =   love.graphics.getHeight()/2
    -- Building the menu items
    for k,v in pairs(item_list) do
        local item  =   MenuItem( item_list[k], value_list[k])
        --~ item.value  =   value_list[k]

        local xpos  =   love.graphics.getWidth()/2 - item.rect.width/2
        item:setPos( xpos, ypos )
        ypos = ypos+line_offset

        function item:onClick()
            print("Clicked on : "..self.label)
            if item.label=="Fullscreen" then
                GAMECONFIG:toggle("fullscreen")
                self.value  =   GAMECONFIG.options["fullscreen"]
                GAMECONFIG:saveToFile()

            elseif item.label=="Post processing" then
                GAMECONFIG:toggle("post-process")
                self.value  =   GAMECONFIG.options["post-process"]
                GAMECONFIG:saveToFile()

            elseif item.label=="Resolution" then


            elseif item.label=="Back" then
                TRANSITION:goTo(optionmenu)
            end
        end
        table.insert(menu, item)
    end

end

function graphicsoption:init()
    --Instanciate options items


end

function graphicsoption:update(dt)
    menucam:move(math.sin(gametime)/8,math.cos(gametime*0.5)/8)
    TRANSITION:update(dt)
    for k, item in pairs(menu) do
        item:update(dt)

        x, y = love.mouse.getPosition()
        if item:contains(x, y) then
            item:onHover()

        end
    end
end

function graphicsoption:keyreleased(key, unicode)
    for k, item in pairs(menu) do
        if item:contains(m_x, m_y) then
            item:onClick()
        end
    end
end

function graphicsoption:mousereleased(m_x, m_y, button)
    for k, item in pairs(menu) do
        if item:contains(m_x, m_y) then
            item:onClick()
        end
    end
end

function graphicsoption:draw()
    menucam:attach()
    --Drawing back image
    love.graphics.draw(background.image, background.pos:unpack())
    menucam:detach()

    love.graphics.setFont(big_font)
    for k, item in ipairs(menu) do
        item:draw()

    end

    if DEBUG then debug_draw_stats(menucam) end
    watermark()

end
