------------------------------------------------------------------------
-- OPTIONS MENU - allows to change sound and display parameters
------------------------------------------------------------------------
optionmenu              =   Gamestate.new()
optionmenu.position     =   vector(1050, 140)
optionmenu.rotation     =   0
optionmenu.zoom         =   1.5



function optionmenu:init()


end

function optionmenu:enter()
    item_list   =   {"Display", "Sound", "Language", "Back"}
    value_list  =   {nil, nil, GAMECONFIG.options["locale"], nil}
    line_offset =   (love.graphics.getHeight()/2) / #item_list
    line_offset =   line_offset -   big_font:getHeight()
    menu        =   {}

    ypos  =   love.graphics.getHeight()/2
    -- Building the menu items
    for k,v in pairs(item_list) do
        local item  =   MenuItem( item_list[k], value_list[k] )

        local xpos  =   love.graphics.getWidth()/2 - item.rect.width/2
        item:setPos( xpos, ypos )
        ypos = ypos+line_offset
        function item:onClick()
            print("Clicked on : "..self.label)
            self:click()
            if item.label=="Language" then
                if GAMECONFIG.options["locale"]=="en" then
                    GAMECONFIG.options["locale"]="fr"
                else
                    GAMECONFIG.options["locale"]="en"
                end
                self.value  =   GAMECONFIG.options["locale"]
                setLocale(GAMECONFIG.options["locale"])
                GAMECONFIG:saveToFile()
            elseif item.label=="Display" then
                TRANSITION:goTo(graphicsoption)

            elseif item.label=="Sound" then
                TRANSITION:goTo(soundoption)

            elseif item.label=="Back" then
                TRANSITION:goTo(mainmenu)
            end
        end
        table.insert(menu, item)
    end

end

function optionmenu:update(dt)
    menucam:move(math.sin(gametime)/8,math.cos(gametime*0.5)/8)
    TRANSITION:update(dt)
    for k, item in pairs(menu) do
        item:update(dt)

        x, y = love.mouse.getPosition()
        if item:contains(x, y) then
            item:onHover()

        end
    end
end

function optionmenu:draw()
    menucam:attach()
    --Drawing back image
    love.graphics.draw(background.image, background.pos:unpack())
    menucam:detach()

    love.graphics.setFont(big_font)
    for k, item in ipairs(menu) do
        item:draw()

    end

    if DEBUG then debug_draw_stats(menucam) end
    watermark()
end

function optionmenu:keyreleased(key, unicode)
    if key=="escape" then
        TRANSITION:goTo(mainmenu)
    end
end

function optionmenu:mousereleased(m_x, m_y, button)
    for k, item in pairs(menu) do
        if item:contains(m_x, m_y) then
            item:onClick()
        end
    end
end
